//------------------------------------------------------------------
//
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1  DeepSkyBlue
#property indicator_color2  Blue
#property indicator_color3  Maroon
#property indicator_color4  Red
#property indicator_minimum 0
#property indicator_maximum 1
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_width4  2

extern string TimeFrame          = "Current time frame";
extern int    NmrLength          = 20;
extern bool   WrongWay           = false;
extern bool   alertsOn           = false;
extern bool   alertsOnCurrent    = false;
extern bool   alertsOnZeroCross  = true;
extern bool   alertsOnBandCross  = true;
extern bool   alertsSound        = false;
extern bool   alertsMessage      = true;
extern bool   alertsNotification = false;
extern bool   alertsEmail        = false;

//
//
//
//
//

double histuu[];
double histud[];
double histdd[];
double histdu[];
double trendz[];
double trendu[];
double trendd[];
string indicatorFileName;
bool   returnBars;
int    timeFrame;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//

int init()
{
   IndicatorBuffers(7);
   SetIndexBuffer (0,histuu); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer (1,histud); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer (2,histdu); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer (3,histdd); SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer (4,trendz);
   SetIndexBuffer (5,trendu);
   SetIndexBuffer (6,trendd);
      indicatorFileName = WindowExpertName();
      returnBars        = TimeFrame == "returnBars";     if (returnBars)     return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);
   IndicatorShortName(timeFrameToString(timeFrame)+" nmr ("+NmrLength+")");      
  return(0);
}
int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double work[][3];
#define _valm 0
#define _valu 1
#define _vald 2
int start()
{
  int r,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-NmrLength-1);
         if (returnBars) { histuu[0] = limit+1; return(0); }
         if (timeFrame != Period())
         {
            limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
            for(int i=limit; i>=0; i--)
            {
               int y = iBarShift(NULL,timeFrame,Time[i]);               
                  histuu[i] = iCustom(NULL,timeFrame,indicatorFileName,"",NmrLength,WrongWay,alertsOn,alertsOnCurrent,alertsOnZeroCross,alertsOnBandCross,alertsSound,alertsMessage,alertsNotification,alertsEmail,0,y);
                  histud[i] = iCustom(NULL,timeFrame,indicatorFileName,"",NmrLength,WrongWay,alertsOn,alertsOnCurrent,alertsOnZeroCross,alertsOnBandCross,alertsSound,alertsMessage,alertsNotification,alertsEmail,1,y);
                  histdu[i] = iCustom(NULL,timeFrame,indicatorFileName,"",NmrLength,WrongWay,alertsOn,alertsOnCurrent,alertsOnZeroCross,alertsOnBandCross,alertsSound,alertsMessage,alertsNotification,alertsEmail,2,y);
                  histdd[i] = iCustom(NULL,timeFrame,indicatorFileName,"",NmrLength,WrongWay,alertsOn,alertsOnCurrent,alertsOnZeroCross,alertsOnBandCross,alertsSound,alertsMessage,alertsNotification,alertsEmail,3,y);
            }
            return(0);
         }

   //
   //
   //
   //
   //

   if (ArrayRange(work,0)!=Bars) ArrayResize(work,Bars);
   for(i=limit, r=Bars-i-1; i>=0; i--,r++)
   {
      double sum=0,sum2=0,x=0,z=0;
      for (int k=0; k<NmrLength; k++)
      {
         if (k>0)
         {
            sum  += MathAbs(MathLog(Close[i+k])*100000 - MathLog(Close[i+k+1])*100000);
            sum2 += MathAbs(MathLog(Close[i+k])*100000 - MathLog(Close[i+k+1])*100000)*(MathSqrt(k+1)-MathSqrt(k));
         }
         else z += MathAbs(MathLog(Close[i+k])*100000 - MathLog(Close[i+k+1])*100000);
              x +=        (MathLog(Close[i]  )*100000 - MathLog(Close[i+k+1])*100000)/MathSqrt(k+1);
      }
      
      //
      //
      //
      //
      //
      
      z += sum2; x /= (NmrLength*1.0);  double ratio = 1; if (sum!=0) ratio = MathRound(sum2)/MathRound(sum);
         if (WrongWay)
            {
               work[r][_valm] =  ratio*x;
               work[r][_valu] =  ratio*ratio*z;
            }
         else
            {
               work[r][_valm] =  work[r-1][_valm]+ratio*(x-work[r-1][_valm]);
               work[r][_valu] =  work[r-1][_valu]+ratio*(z*ratio - work[r-1][_valu]);
            }         
            work[r][_vald] = -work[r][_valu];
            trendz[i] = trendz[i+1];
            trendu[i] = trendu[i+1];
            trendd[i] = trendd[i+1];
               if (work[r][_valm]>0)              trendz[i] =  1;
               if (work[r][_valm]<0)              trendz[i] = -1;
               if (work[r][_valm]>work[r][_valu]) trendu[i] =  1;
               if (work[r][_valm]<work[r][_valu]) trendu[i] = -1;
               if (work[r][_valm]>work[r][_vald]) trendd[i] =  1;
               if (work[r][_valm]<work[r][_vald]) trendd[i] = -1;
            histuu[i] = EMPTY_VALUE;               
            histud[i] = EMPTY_VALUE;               
            histdu[i] = EMPTY_VALUE;               
            histdd[i] = EMPTY_VALUE;               
            if (trendz[i]==1)
               if (trendu[i]==1)
                     histuu[i] = 1;
               else  histud[i] = 1;  
            else
               if (trendd[i]==1)
                     histdu[i] = 1;
               else  histdd[i] = 1;  
   }
   manageAlerts();
   return(0);
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      
      //
      //
      //
      //
      //
      
      static string   alertType1 = "";
      static datetime alertTime1 = 0;
      if (alertsOnZeroCross && trendz[whichBar] != trendz[whichBar+1])
      {
         if (trendz[whichBar] ==  1) doAlert(alertType1,alertTime1,"nmr crossed level 0 up");
         if (trendz[whichBar] == -1) doAlert(alertType1,alertTime1,"nmr crossed level 0 down");
      }
      static string   alertType2 = "";
      static datetime alertTime2 = 0;
      if (alertsOnBandCross && trendu[whichBar] != trendu[whichBar+1])
      {
         if (trendu[whichBar] ==  1) doAlert(alertType2,alertTime2,"nmr crossed upper band up");
         if (trendu[whichBar] == -1) doAlert(alertType2,alertTime2,"nmr crossed upper band down");
      }
      static string   alertType3 = "";
      static datetime alertTime3 = 0;
      if (alertsOnBandCross && trendd[whichBar] != trendd[whichBar+1])
      {
         if (trendd[whichBar] ==  1) doAlert(alertType3,alertTime3,"nmr crossed lower band up");
         if (trendd[whichBar] == -1) doAlert(alertType3,alertTime3,"nmr crossed lower band down");
      }
   }
}

//
//
//
//
//

void doAlert(string& previousAlert, datetime& previousTime, string doWhat)
{
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[0]) {
       previousAlert  = doWhat;
       previousTime   = Time[0];

       //
       //
       //
       //
       //

       message = timeFrameToString(Period())+" "+Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+"  "+doWhat;
          if (alertsMessage)      Alert(message);
          if (alertsEmail)        SendMail(StringConcatenate(Symbol(),"nmr"),message);
          if (alertsNotification) SendNotification(StringConcatenate(Symbol(),"nmr "+message));
          if (alertsSound)        PlaySound("alert2.wav");
   }
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}